Index: /trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F
===================================================================
--- /trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2485)
+++ /trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2486)
@@ -71,4 +71,5 @@
       USE param_v4_h
       USE compo_hedin83_mod2
+      use radlwsw_newtoncool_mod, only: radlwsw_newtoncool
 !      use ieee_arithmetic
       use time_phylmdz_mod, only: annee_ref, day_ref, itau_phy
@@ -1501,7 +1502,5 @@
 c       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       if (physideal) then
-       CALL radlwsw_newtoncool
-     e            (dist, rmu0, fract, zzlev,
-     e             paprs, pplay,ftsol, t_seri)
+       CALL radlwsw_newtoncool(presnivs,t_seri)
       else
        CALL radlwsw
Index: /trunk/LMDZ.VENUS/libf/phyvenus/radlwsw_NewtonCool.F
===================================================================
--- /trunk/LMDZ.VENUS/libf/phyvenus/radlwsw_NewtonCool.F	(revision 2485)
+++ /trunk/LMDZ.VENUS/libf/phyvenus/radlwsw_NewtonCool.F	(revision 2486)
@@ -2,40 +2,29 @@
 ! $Header: /home/cvsroot/LMDZ4/libf/phylmd/radlwsw.F,v 1.2 2004/10/27 10:14:46 lmdzadmin Exp $
 !
-      SUBROUTINE radlwsw_newtoncool(dist, rmu0, fract, zzlev,
-     .                  paprs, pplay,tsol, pt)
+      MODULE radlwsw_newtoncool_mod
+      
+      implicit none
+      
+      contains
+      
+      SUBROUTINE radlwsw_newtoncool(presnivs,pt)
       
 c======================================================================
-c Auteur(s): Z.X. Li (LMD/CNRS) date: 19960719
-c Objet: interface entre le modele et les rayonnements
-c Arguments:
-c dist-----input-R- distance astronomique terre-soleil
-c rmu0-----input-R- cosinus de l'angle zenithal
-c fract----input-R- duree d'ensoleillement normalisee
-c paprs----input-R- pression a inter-couche (Pa)
-c pplay----input-R- pression au milieu de couche (Pa)
-c tsol-----input-R- temperature du sol (en K)
-c pt-------input-R- temperature (K)
-c
-      
 c   S. Lebonnois    12/04/2007
 c  VERSION NEWTONIAN COOLING pour Venus (no diurnal cycle)
 c  update 01/2014
-
 c======================================================================
-      use dimphy
+      use dimphy, only: klon,klev
       USE geometry_mod, ONLY: latitude ! in radians
       USE phys_state_var_mod, only: heat,cool,radsol,
      .  topsw,toplw,solsw,sollw,sollwdown,lwnet,swnet,zt_eq
-      USE write_field_phy
+
       IMPLICIT none
-#include "YOMCST.h"
-#include "clesphys.h" 
+      include "YOMCST.h"
 
 c ARGUMENTS
-      real rmu0(klon), fract(klon), dist
  
-      real zzlev(klon,klev+1),paprs(klon,klev+1), pplay(klon,klev)
-      real tsol(klon)
-      real pt(klon,klev)
+      real,intent(in) :: presnivs(klev) ! approx. pressure of GCM levels (Pa)
+      real,intent(in) :: pt(klon,klev) ! atmospheric temperature (K)
  
 c LOCAL VARIABLES
@@ -71,7 +60,5 @@
 c
 
-      logical firstcall
-      data    firstcall/.true./
-      save    firstcall
+      logical,save :: firstcall=.true.
       
 c  Initialisations
@@ -79,5 +66,5 @@
 
       if (firstcall) then
-
+        ! build zt_eq(), reference temperature field towards which to relax.
         PRINT*,"******* ATTENTION, NEWTONIAN COOLING ********"
 
@@ -90,8 +77,8 @@
             level = 1
 	    do j=1,nlevCLee
-	      if (pressCLee(j).gt.pplay(i,k)) level = j
+	      if (pressCLee(j).gt.presnivs(k)) level = j
 	    enddo
 	    
-	    fact  = (log10(pplay(i,k))-log10(pressCLee(level)))
+	    fact  = (log10(presnivs(k))-log10(pressCLee(level)))
      .        /(log10(pressCLee(level+1))-log10(pressCLee(level)))
 	    ztemp = tempCLee(level)*(1-fact)+tempCLee(level+1)*fact
@@ -104,4 +91,5 @@
         ENDDO !i
 
+        firstcall = .false.
       endif ! firstcall
       
@@ -133,6 +121,5 @@
 c+++++++ FIN BOUCLE SUR LA GRILLE +++++++++++++++++++++++++
 
-      firstcall = .false.
-      RETURN
-      END
+      END SUBROUTINE radlwsw_newtoncool
 
+      END MODULE radlwsw_newtoncool_mod